
{$I PHONE.PAS}

Var
  PhoneFile : File;
  Pt        : PhoneRec;
  Entry     : Word;
  Err       : Word;

Procedure FatalError(s:string);
Begin
  WriteLn(s+#10#10);
  Halt;
End;


Begin

  WriteLn(#13#10'Terminate 3 -> Phonebook Password Insert -> FREEWARE by Bo Bendtsen'#10);

  If Paramcount<>3 Then
  Begin
    WriteLn('Syntax : Phonebook Entry Password');
    WriteLn('Example: TERMINAT.FON 4 SECRET');
    Halt;
  End;

  Assign(PhoneFile,Paramstr(1));

  {$I-} Reset(PhoneFile,1); {$I+}
  If IOResult<>0 Then FatalError('Error opening '+Paramstr(1));

  {$I-} BlockRead(PhoneFile,PHead,Sizeof(PHead)); {$I+}
  If IOResult<>0 Then FatalError('Error in start of phonebook');

  Val(Paramstr(2),Entry,Err);
  If Entry>PHead.Num Then FatalError('Entry number out of range');

  {$I-} Seek(PhoneFile,Entry*Sizeof(Pt)+Sizeof(Phead)); {$I+}
  If IOResult<>0 Then FatalError('Error reading phonebook');

  {$I-} BlockRead(PhoneFile,Pt,Sizeof(Pt)); {$I+}
  If IOResult<>0 Then FatalError('Error in phonebook');

  Pt.Password:=Copy(Paramstr(3),1,Sizeof(Pt.Password)-1);

  {$I-} Seek(PhoneFile,Entry*Sizeof(Pt)+Sizeof(Phead)); {$I+}
  {$I-} BlockWrite(PhoneFile,Pt,Sizeof(Pt)); {$I+}
  If IOResult<>0 Then FatalError('Error writing to phonebook');

  Close(PhoneFile);

  WriteLn('Password inserted for: '+Pt.Name);

End.

