{--------------------------------------------------------------------------}
{                                                                          }
{              -=> Host user structure 4.00 T-USERS.BBS <=-                }
{                                                                          }
{                       Export users to textfile                           }
{                                                                          }
{  Structure is copyrighted material and may not be changed by other than  }
{                       Strathrory Systems Limited                         }
{                                                                          }
{--------------------------------------------------------------------------}

Type
  USERSrecord    = record
                     Name           : String[50];
                     Password       : String[24];
                     Security       : Char;         { S = Supervisor }
                                                    { C = CoSysop }
                                                    { P = Privileged }
                                                    { N = Normal }
                     Organisation,
                     Address1,
                     Address2,
                     Address3       : String[50];
                     Comment        : String[50];
                     DataPhone,
                     VoicePhone     : String[25];
                     Expire         : Word;
                     FirstDate,
                     LastDate       : Word;
                     LastTime       : Word;
                     TimePerDay     : Word;

                     CallBack,
                     CBPrefix,
                     CBSuffix       : Byte;
                     CBNumber       : String[25];

                     TimeUsedToday  : Word;
                     Attribute      : Byte;
                      { Bit 0 : Deleted }
                      { Bit 1 : Guest }
                     PrivatePath    : String[46];
                     FreeSpace      : Array[1..39] of Byte;
                   End;

{----------------------------------------------------------------------------}

Var
  User : UsersRecord;
  UserFile : File of UsersRecord;

Begin
  Assign(UserFile,'T-USERS.BBS');
  {$I-} Reset(UserFile); {$I+}
  If IOResult=0 Then
  Begin
    While Not Eof(UserFile) Do
    Begin
      Read(UserFile,User);
      WriteLn(User.Name+', '+User.Password);
    End;
    Close(UserFile);
  End
  Else WriteLn('Could not open T-USERS.BBS');
End.

